<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: matrix_math_functions_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_571b715927b0d4b7bee37d60dac387ec.html">matrix</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">matrix_math_functions_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2006  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_MATRIx_MATH_FUNCTIONS_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_MATRIx_MATH_FUNCTIONS_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;matrix_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">//                          Exponential Functions </span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">const</span> matrix_exp exp (</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    );</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">const</span> matrix_exp log10 (</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    );</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">const</span> matrix_exp log (</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    );</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">const</span> matrix_exp sqrt (</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    );</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">const</span> matrix_exp pow (</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="keyword">const</span> T&amp; e</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    );</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keyword">const</span> matrix_exp pow (</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keyword">const</span> T&amp; b,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    );</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keyword">const</span> matrix_exp squared (</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    );</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keyword">const</span> matrix_exp cubed (</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    );</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment">//                               Miscellaneous</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keyword">const</span> matrix_exp sign (</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    );</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">const</span> matrix_exp sigmoid (</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    );</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160; </div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">const</span> matrix_exp abs (</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    );</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160; </div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keyword">const</span> matrix_exp reciprocal (</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    );</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keyword">const</span> matrix_exp reciprocal_max (</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    );</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160; </div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keyword">const</span> matrix_exp normalize (</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    );</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="comment">//                          Rounding numbers one way or another</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keyword">const</span> matrix_exp round (</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    );</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    <span class="keyword">const</span> matrix_exp ceil (</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    );</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keyword">const</span> matrix_exp floor (</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    );</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <span class="keyword">const</span> matrix_exp round_zeros (</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    );</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160; </div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <span class="keyword">const</span> matrix_exp round_zeros (</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m,</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        <a class="code" href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">matrix_exp::type</a> eps </div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    );</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="comment">//                              Complex number utility functions</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160; </div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="keyword">const</span> matrix_exp conj (</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    );</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160; </div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    <span class="keyword">const</span> matrix_exp norm (</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    );</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160; </div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    <span class="keyword">const</span> matrix_exp imag (</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    );</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <span class="keyword">const</span> matrix_exp real (</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    );</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160; </div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    <span class="keyword">const</span> matrix_exp complex_matrix (</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; real_part</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    );</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160; </div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    <span class="keyword">const</span> matrix_exp complex_matrix (</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; real_part,</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; imag_part</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    );</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;<span class="comment">//                              Trigonometric Functions </span></div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160; </div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    <span class="keyword">const</span> matrix_exp sin (</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    );</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160; </div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;    <span class="keyword">const</span> matrix_exp cos (</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    );</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160; </div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    <span class="keyword">const</span> matrix_exp tan (</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    );</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160; </div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;    <span class="keyword">const</span> matrix_exp asin (</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    );</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160; </div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;    <span class="keyword">const</span> matrix_exp acos (</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;    );</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160; </div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;    <span class="keyword">const</span> matrix_exp atan (</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;    );</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160; </div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;    <span class="keyword">const</span> matrix_exp sinh (</div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;    );</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160; </div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;    <span class="keyword">const</span> matrix_exp cosh (</div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;    );</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160; </div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;    <span class="keyword">const</span> matrix_exp tanh (</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;        <span class="keyword">const</span> matrix_exp&amp; m</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;    );</div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160; </div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;}</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160; </div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;<span class="preprocessor">#endif // DLIB_MATRIx_MATH_FUNCTIONS_ABSTRACT_</span></div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1matrix__exp_html_a039e80e9a67ddd1abaa4a1004dab7254"><div class="ttname"><a href="classdlib_1_1matrix__exp.html#a039e80e9a67ddd1abaa4a1004dab7254">dlib::matrix_exp::type</a></div><div class="ttdeci">matrix_traits&lt; EXP &gt;::type type</div><div class="ttdef"><b>Definition:</b> matrix_exp.h:126</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
